/****************************************************************
*	HEAPCHK.C - Heap checking function demonstration			*
*																*
*	To compile: "cl /Od /Zi /AS heapchk.c"						*
****************************************************************/

#include <stdio.h>			/* NULL								*/
#include <malloc.h>			/* _heapchk(), _HEAP...				*/

/****************************************************************
*	HeapCheck - Debugging function for CodeView.				*
*																*
*	OUT:	pointer to string representing heap status			*
****************************************************************/
long HeapCheckCount=0;		/* Global, so its always in scope	*/
char *HeapCheck(void)
	{
	++HeapCheckCount;		/* Show that we called it again		*/
	switch (_heapchk())
		{
		case _HEAPOK:		return "Heap: OK";
		case _HEAPEMPTY:	return "Heap: Empty";
		case _HEAPBADBEGIN:	return "Heap: Bad start";
		case _HEAPBADNODE:	return "Heap: Bad node";
		}
	return "Heap: Bad _heapchk() call";
	}

/****************************************************************
*	main - allocate a node NODESIZE bytes long, then destroy	*
*	different parts of the heap.								*
****************************************************************/
#define NODESIZE	 10		/* Size of the allocated node		*/
char *p;					/* Pointer to the allocated node	*/
void main(void)
	{
	int i, j;
	extern unsigned _nheap_desc;

	/* HeapCheck should show "OK" here */
	puts("Allocate the node");						/* BP */
	p = malloc(NODESIZE);
	if (p == NULL)
		{
		puts("ERROR: can't allocate a node!");
		exit(1);
		}

	/* HeapCheck should show "OK" here */
	puts("Destroy the node");						/* BP */
	for (i = 0; i < NODESIZE+15; i++)
		p[i]=0;

	/* HeapCheck should show "Bad node" here, assuming max >= 2	*/
	puts("Destroy the initial heap descriptor");
	_nheap_desc = 0;								/* BP */

	/* HeapCheck should show "Bad start" here */
	puts("Heap is totally destroyed");
	}
